VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSystray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'<CSCC>
Option Explicit
Private Declare Function Shell_NotifyIcon _
                Lib "shell32" _
                Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, _
                                           pnid As NOTIFYICONDATA) As Boolean
Private Declare Function Shell_NotifyIconW _
                Lib "shell32" (ByVal dwMessage As Long, _
                               pnid As NOTIFYICONDATAW) As Boolean
'NT or not (Para el problema con los balones informativos)
Private Declare Function GetVersionEx _
                Lib "kernel32" _
                Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type
Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type
Private Type NOTIFYICONDATAW
    cbSize As Long
    hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip(0 To 255) As Byte
    dwState As Long
    dwStateMask As Long
    szInfo(0 To 511) As Byte
    uTimeOutOrVersion As Long
    szInfoTitle(0 To 127) As Byte
    dwInfoFlags As Long
    guidItem As Long
End Type
Dim NID As NOTIFYICONDATA
Dim NIDW As NOTIFYICONDATAW
Private Const NOTIFYICONDATA_V2_SIZE_U = 936
Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4
Private Const NIF_INFO = &H10
Private Const NIF_DOALL = NIF_MESSAGE Or NIF_ICON Or NIF_TIP Or NIF_INFO
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_RBUTTONDBLCLK = &H206
Public Enum EBalloonIconTypes
    NIIF_NONE = 0
    NIIF_INFO = 1
    NIIF_WARNING = 2
    NIIF_ERROR = 3
End Enum
Private os_NT As Boolean

Private Sub StringToArray(ByVal sString As String, _
                          bArray() As Byte, _
                          ByVal lMaxSize As Long)
    Dim b() As Byte
    Dim i As Long
    Dim j As Long

    If Len(sString) > 0 Then
        b = sString

        For i = LBound(b) To UBound(b)
            bArray(i) = b(i)

            If (i = (lMaxSize - 2)) Then
                Exit For
            End If

        Next

        For j = i To lMaxSize - 1
            bArray(j) = 0
        Next

    End If

End Sub

Public Sub Ico_Create(fForm As Form, _
                      oIcon As Object, _
                      sTip As String) '98 & 2k & Xp

    If os_NT Then
        'init for 2k & Xp
        NIDW.uFlags = NIF_DOALL
        NIDW.cbSize = NOTIFYICONDATA_V2_SIZE_U
        NIDW.hwnd = fForm.hwnd
        NIDW.uID = vbNull
        NIDW.uCallbackMessage = WM_MOUSEMOVE
        NIDW.hIcon = oIcon
        StringToArray sTip, NIDW.szTip, 64
        Shell_NotifyIconW NIM_ADD, NIDW
    Else
        'init for 98
        NID.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        NID.cbSize = Len(NID)
        NID.hwnd = fForm.hwnd
        NID.uID = vbNull
        NID.uCallbackMessage = WM_MOUSEMOVE
        NID.hIcon = oIcon
        NID.szTip = sTip & vbNullChar
        Shell_NotifyIcon NIM_ADD, NID
    End If

End Sub

Public Sub Ico_Delete() '98 & 2k & Xp

    If os_NT Then
        Shell_NotifyIconW NIM_DELETE, NIDW
    Else
        Shell_NotifyIcon NIM_DELETE, NID
    End If

End Sub

Public Sub Ico_Mouse(ByVal X As Integer, _
                     ByVal Escala As Byte)  '98 & 2k & Xp

    If Not Escala = vbPixels Then
        X = X / Screen.TwipsPerPixelX
    End If

    Select Case X
            
        Case WM_LBUTTONDOWN

                Principal.Show
                Principal.tmrSalir.Enabled = True

        Case WM_RBUTTONDOWN
            StopTimer
            End
        Case WM_LBUTTONUP

        Case WM_RBUTTONUP

        Case WM_LBUTTONDBLCLK
            StopTimer
            End
        Case WM_RBUTTONDBLCLK

    End Select

End Sub

Public Sub Ico_Show_Bal(sMessage As String, _
                        sTitle As String, _
                        sInfoType As String, _
                        Optional iTimeOutMiliSec As Integer = 5000) 'SystrayBalloon 2k & Xp, no error on 98 if used

    If os_NT Then
        NIDW.uFlags = NIF_DOALL
        StringToArray sTitle, NIDW.szInfoTitle, 128
        StringToArray sMessage, NIDW.szInfo, 512

        Select Case sInfoType

            Case 0
                NIDW.dwInfoFlags = NIIF_NONE

            Case 1
                NIDW.dwInfoFlags = NIIF_INFO

            Case 2
                NIDW.dwInfoFlags = NIIF_WARNING

            Case 3
                NIDW.dwInfoFlags = NIIF_ERROR
        End Select

        NIDW.uTimeOutOrVersion = iTimeOutMiliSec
        Shell_NotifyIconW NIM_MODIFY, NIDW
        
    End If

End Sub

Public Sub Ico_Upd_Icon(oIcon_New As Object) '98 & 2k & Xp

    If os_NT Then
        NIDW.uFlags = NIF_ICON
        NIDW.hIcon = oIcon_New
        Shell_NotifyIconW NIM_MODIFY, NIDW
    Else
        NID.uFlags = NIF_ICON
        NID.hIcon = oIcon_New
        Shell_NotifyIcon NIM_MODIFY, NID
    End If

End Sub

Public Sub Ico_Upd_Tip(sTipMsg As String) '98 & 2k & Xp

    If os_NT Then
        NIDW.uFlags = NIF_TIP
        StringToArray sTipMsg, NIDW.szTip, 64
        Shell_NotifyIconW NIM_MODIFY, NIDW
    Else
        NID.uFlags = NIF_TIP
        NID.szTip = sTipMsg & vbNullChar
        Shell_NotifyIcon NIM_MODIFY, NID
    End If

End Sub

Private Sub Class_Initialize()
    os_NT = osNT
End Sub

Private Function osNT() As Boolean
    Dim OSInfo As OSVERSIONINFO
    OSInfo.dwOSVersionInfoSize = Len(OSInfo)
    GetVersionEx OSInfo
    osNT = (OSInfo.dwPlatformId = 2)
End Function
